vexalarm = {}
vexalarm.AceConfigDialog = LibStub("AceConfigDialog-3.0", true)
vexalarm.AceConfig = LibStub("AceConfig-3.0", true)
vexalarm.AceConsole= LibStub("AceConsole-3.0", true)
vexalarm.LSM = LibStub("LibSharedMedia-3.0", true)
vexalarm.LSMWidgets = LibStub("AceGUI-3.0-SharedMediaWidgets", true)
vexalarm.Locale = LibStub("AceLocale-3.0"):GetLocale("Vex Alarm")

--Start values
vexalarm.infight = false
vexalarm.last_spell_id = ""
vexalarm.last_spell_timestamp = 0
vexalarm.last_spell_event = ""
vexalarm.last_spell_caster = ""
vexalarm.last_spell_id_RW = ""
vexalarm.last_spell_timestamp_RW = 0
vexalarm.last_spell_event_RW = ""
vexalarm.last_spell_caster_RW = ""
vexalarm.proclaims = {}
vexalarm.proclaimPlaces = {}
vexalarm.show = true
vexalarm.loadings = 0
vexalarm.totemsPlaced = {}
vexalarm.totemsPlaced_RW = {}
vexalarm.testmode = false
vexalarm.wrongspells = {}
vexalarm.registeredFrames = 1
vexalarm.incomeMsgs = {}
vexalarm.incomeSpellProfiles = {}
vexalarm.SentMsgs = {}

SLASH_VEXALARM1 = "/vexalarm"
SLASH_VEXALARM2 = "/vexa"
function SlashCmdList.VEXALARM(msg, editbox)
	local command, args = msg:match("^(%S*)%s*(.-)$")
	
	if command == "" or command == "option" or command == "options" or command == "config" or command == "configs" then
		InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel)
	elseif command == "profile" then
		vexalarm_spellprofile_load(args, true)
	elseif command == "defaults" then
		print("|CFFFF7D0AVex Alarm|r - "..vexalarm.Locale["print defaults loaded"])
		vexalarm_loaddefaults(true)
	elseif command == "test" then
		vexdebugs.print(vexalarm_spellprofiles["test"]["6795"],'vexalarm_spellprofiles["test"]["6795"]')
	elseif command == "enable" then
		vexalarm_parameters["enable"]=not(vexalarm_parameters["enable"]) vexalarm_checkshow()
		if vexalarm_parameters["enable"] then
			print("|CFFFF7D0AVex Alarm|r - Addon "..vexalarm.Locale["print addon enabled"])
		else
			print("|CFFFF7D0AVex Alarm|r - Addon "..vexalarm.Locale["print addon disabled"])
		end
	elseif command == "wrongspells" then
		vexdebugs.print(vexalarm.wrongspells, "vexalarm.wrongspells")
	elseif command == "rw" then
		vexalarm_parameters["rw"]["activate"] = not(vexalarm_parameters["rw"]["activate"])
		if vexalarm_parameters["rw"]["activate"] then
			print("|CFFFF7D0AVex Alarm|r - Raid Warnings "..vexalarm.Locale["print addon enabled"])
		else
			print("|CFFFF7D0AVex Alarm|r - Raid Warnings "..vexalarm.Locale["print addon disabled"])
		end
	else
		print ("|CFFFF7D0AVex Alarm|r "..vexalarm.Locale["print cmd not found"])
		print ("|CFFFF7D0A/vexalarm|r "..vexalarm.Locale["print slashs useable"])
		print ("|CFFFF7D0A/vexalarm|r option/options/config/configs - "..vexalarm.Locale["print slashs options"])
		print ("|CFFFF7D0A/vexalarm|r defaults - "..vexalarm.Locale["print slashs defaults"])
		print ("|CFFFF7D0A/vexalarm|r profile "..vexalarm.Locale["print slashs profile"])
		print ("|CFFFF7D0A/vexalarm|r enable - "..vexalarm.Locale["print slashs enable"])
		print ("|CFFFF7D0A/vexalarm|r rw - "..vexalarm.Locale["print slashs rw"])
	end
end

function vexalarm_OnEvent(self, event, ...)
	if event == "PLAYER_LOGIN" then
		vexalarm_initialize()
		print("|CFFFF7D0AVex Alarm|r loaded")
	elseif event == "PLAYER_REGEN_DISABLED" then
		vexalarm.infight = true
		vexalarm_checkshow()
	elseif event == "PLAYER_REGEN_ENABLED" then
		vexalarm.infight = false
		vexalarm_checkshow()
	elseif event == "CHAT_MSG_ADDON" then
		if select(4, ...) ~= select(1, UnitName("player")) then
			local prefix = select(1, ...)
			local msg = select(2, ...)
			local sender = select(4, ...)
			if prefix == "VEXALARM_SP" then
				vexalarm_ReceiveSpellProfile(msg, sender)
			elseif prefix == "VEXALARM_SP_RE" then
				vexalarm_ReceiveSpellProfileRE(msg, sender)
			end
		end
	else
		if vexalarm.show then
			vexalarm_check_fulltext()
			local eventchar  = select(2, ...)
			if eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_AURA_REMOVED" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT" then
				local caster = select(5, ...)
				local spellid = select(12, ...)
				local spellname = select(13, ...)
				local target = select(9, ...)
				if vexalarm_myspellcheck(caster) and vexalarm_showgrpcheck(caster) then
					local status = eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT"
					local alarmtype = vexalarm_spellcheck(spellid, caster, eventchar)
					if(alarmtype ~="" and alarmtype ~="dejavue") then
						vexalarm_proclaim(alarmtype, spellname, spellid, caster, target, status)				
					end
					
					if vexalarm_parameters["rw"]["activate"] then
						alarmtype = vexalarm_spellcheck(spellid, caster, eventchar, true)
						if(alarmtype ~="" and alarmtype ~="dejavue") then
							vexalarm_proclaim_RW(alarmtype, spellname, spellid, caster, target, status)				
						end
					end
				end
			elseif eventchar == "UNIT_DESTROYED" then
				vexalarm_totem_clean()
				
				local spellname = select(9, ...)
				if vexalarm_totem_find(spellname) then
					local alarmtype = vexalarm.totemsPlaced[spellname][2][1]
					local spellid = vexalarm.totemsPlaced[spellname][2][2]
					local caster = vexalarm.totemsPlaced[spellname][2][3]
					local target = vexalarm.totemsPlaced[spellname][2][4]
					if vexalarm_myspellcheck(caster) and vexalarm_showgrpcheck(caster) then
						vexalarm_proclaim(alarmtype, spellname, spellid, caster, target, false)
						vexalarm_totem_delete(spellname)
					end
				end
				
				if vexalarm_totem_find_RW(spellname) then
					local alarmtype = vexalarm.totemsPlaced_RW[spellname][2][1]
					local spellid = vexalarm.totemsPlaced_RW[spellname][2][2]
					local caster = vexalarm.totemsPlaced_RW[spellname][2][3]
					local target = vexalarm.totemsPlaced_RW[spellname][2][4]
					if vexalarm_myspellcheck(caster) and vexalarm_showgrpcheck(caster) then
						vexalarm_proclaim_RW(alarmtype, spellname, spellid, caster, target, false)
						vexalarm_totem_delete_RW(spellname)
					end
				end
			end
		end
	end
end

function string:vexalarm_split(splitter)
	local returnvalue = {}
	for part in string.gmatch(self, ".-"..splitter) do
		part = string.gsub(part, splitter, "")
		returnvalue[#returnvalue+1] = part
	end
	return returnvalue
end

function vexalarm_ReceiveSpellProfileRE(msg, sender)
	if vexalarm.SentMsgs[msg] == sender then
		vexalarm.SentMsgs[msg] = nil
		print("|CFFFF7D0AVex Alarm|r - Spellprofile has been successfully sent")
		vexalarm_initialize(true)
	end
end

function vexalarm_ReceiveSpellProfile(msg, sender)
	local content = msg:vexalarm_split(";")	
	
	local timestamp = content[1]
	vexalarm.testTimeStamp = timestamp
	local name = content[2]
	local part = tonumber(content[3])
	local quantity = tonumber(content[4])
	local package = content[5]
	
	if vexalarm.incomeMsgs[timestamp] == nil then
		vexalarm.incomeMsgs[timestamp] = {}
	end
	
	if vexalarm.incomeMsgs[timestamp]["parts"] == nil then
		vexalarm.incomeMsgs[timestamp]["parts"] = {}
	end
	
	if vexalarm.incomeMsgs[timestamp]["received"] == nil then
		vexalarm.incomeMsgs[timestamp]["received"] = {}
		for i=1, quantity do
			vexalarm.incomeMsgs[timestamp]["received"][i] = false
		end
	end
	
	vexalarm.incomeMsgs[timestamp]["received"][part] = true
	vexalarm.incomeMsgs[timestamp]["quantity"] = quantity
	vexalarm.incomeMsgs[timestamp]["parts"][part] = package
	
	local complete = true
	for i,v in ipairs(vexalarm.incomeMsgs[timestamp]["received"]) do
		if not(v) then
			complete = false
		end
	end
	
	if complete then
		vexalarm.incomeSpellProfiles[timestamp] = {}
		
		local text = ""
		for i,v in ipairs(vexalarm.incomeMsgs[timestamp]["parts"]) do
			text = text..v
		end
		
		local data = {}
		local spells = text:vexalarm_split(",")	
		for i, v in ipairs(spells) do
			local spelldata = v:vexalarm_split("=")
			data[spelldata[1]] = {}
			for j=1,4 do
				if string.sub(spelldata[2], j, j) == 1 then
					data[spelldata[1]][j] = true
				else
					data[spelldata[1]][j] = false
				end
			end
		end
		vexalarm.incomeSpellProfiles[timestamp]["data"] = data
						
		vexalarm.incomeSpellProfiles[timestamp]["timestamp"] = date("%d/%m/%y %H:%M")
		vexalarm.incomeSpellProfiles[timestamp]["name"] = name	
		vexalarm_initialize(true)
		print("|CFFFF7D0AVex Alarm|r - Spellprofile from "..sender.." has been successfully received")
		SendAddonMessage("VEXALARM_SP_RE", timestamp , "whisper" , sender)	
	end
end